#include <stdint.h>
//#include <stdlib.h>
#include "KeccakRNG.h"
#include "invmul.h"


uint8_t leakage_visit_counter = 0;
uint32_t leakage_value = 0;

/*
  Tables taken from:
  http://www.cs.utsa.edu/~wagner/laws/FFM.html
*/


const uint8_t sq22[] = {
        0x00, 0x01, 0x5e, 0x5f, 0xe4, 0xe5, 0xba, 0xbb, 0xe8, 0xe9, 0xb6, 0xb7,
        0x0c, 0x0d, 0x52, 0x53, 0x4d, 0x4c, 0x13, 0x12, 0xa9, 0xa8, 0xf7, 0xf6,
        0xa5, 0xa4, 0xfb, 0xfa, 0x41, 0x40, 0x1f, 0x1e, 0x91, 0x90, 0xcf, 0xce,
        0x75, 0x74, 0x2b, 0x2a, 0x79, 0x78, 0x27, 0x26, 0x9d, 0x9c, 0xc3, 0xc2,
        0xdc, 0xdd, 0x82, 0x83, 0x38, 0x39, 0x66, 0x67, 0x34, 0x35, 0x6a, 0x6b,
        0xd0, 0xd1, 0x8e, 0x8f, 0x1d, 0x1c, 0x43, 0x42, 0xf9, 0xf8, 0xa7, 0xa6,
        0xf5, 0xf4, 0xab, 0xaa, 0x11, 0x10, 0x4f, 0x4e, 0x50, 0x51, 0x0e, 0x0f,
        0xb4, 0xb5, 0xea, 0xeb, 0xb8, 0xb9, 0xe6, 0xe7, 0x5c, 0x5d, 0x02, 0x03,
        0x8c, 0x8d, 0xd2, 0xd3, 0x68, 0x69, 0x36, 0x37, 0x64, 0x65, 0x3a, 0x3b,
        0x80, 0x81, 0xde, 0xdf, 0xc1, 0xc0, 0x9f, 0x9e, 0x25, 0x24, 0x7b, 0x7a,
        0x29, 0x28, 0x77, 0x76, 0xcd, 0xcc, 0x93, 0x92, 0x6c, 0x6d, 0x32, 0x33,
        0x88, 0x89, 0xd6, 0xd7, 0x84, 0x85, 0xda, 0xdb, 0x60, 0x61, 0x3e, 0x3f,
        0x21, 0x20, 0x7f, 0x7e, 0xc5, 0xc4, 0x9b, 0x9a, 0xc9, 0xc8, 0x97, 0x96,
        0x2d, 0x2c, 0x73, 0x72, 0xfd, 0xfc, 0xa3, 0xa2, 0x19, 0x18, 0x47, 0x46,
        0x15, 0x14, 0x4b, 0x4a, 0xf1, 0xf0, 0xaf, 0xae, 0xb0, 0xb1, 0xee, 0xef,
        0x54, 0x55, 0x0a, 0x0b, 0x58, 0x59, 0x06, 0x07, 0xbc, 0xbd, 0xe2, 0xe3,
        0x71, 0x70, 0x2f, 0x2e, 0x95, 0x94, 0xcb, 0xca, 0x99, 0x98, 0xc7, 0xc6,
        0x7d, 0x7c, 0x23, 0x22, 0x3c, 0x3d, 0x62, 0x63, 0xd8, 0xd9, 0x86, 0x87,
        0xd4, 0xd5, 0x8a, 0x8b, 0x30, 0x31, 0x6e, 0x6f, 0xe0, 0xe1, 0xbe, 0xbf,
        0x04, 0x05, 0x5a, 0x5b, 0x08, 0x09, 0x56, 0x57, 0xec, 0xed, 0xb2, 0xb3,
        0xad, 0xac, 0xf3, 0xf2, 0x49, 0x48, 0x17, 0x16, 0x45, 0x44, 0x1b, 0x1a,
        0xa1, 0xa0, 0xff, 0xfe
};

const uint8_t sq2[] ={
        0x00, 0x01, 0x10, 0x11, 0x1b, 0x1a, 0x0b, 0x0a, 0xab, 0xaa, 0xbb, 0xba,
        0xb0, 0xb1, 0xa0, 0xa1, 0x5e, 0x5f, 0x4e, 0x4f, 0x45, 0x44, 0x55, 0x54,
        0xf5, 0xf4, 0xe5, 0xe4, 0xee, 0xef, 0xfe, 0xff, 0x97, 0x96, 0x87, 0x86,
        0x8c, 0x8d, 0x9c, 0x9d, 0x3c, 0x3d, 0x2c, 0x2d, 0x27, 0x26, 0x37, 0x36,
        0xc9, 0xc8, 0xd9, 0xd8, 0xd2, 0xd3, 0xc2, 0xc3, 0x62, 0x63, 0x72, 0x73,
        0x79, 0x78, 0x69, 0x68, 0xb3, 0xb2, 0xa3, 0xa2, 0xa8, 0xa9, 0xb8, 0xb9,
        0x18, 0x19, 0x08, 0x09, 0x03, 0x02, 0x13, 0x12, 0xed, 0xec, 0xfd, 0xfc,
        0xf6, 0xf7, 0xe6, 0xe7, 0x46, 0x47, 0x56, 0x57, 0x5d, 0x5c, 0x4d, 0x4c,
        0x24, 0x25, 0x34, 0x35, 0x3f, 0x3e, 0x2f, 0x2e, 0x8f, 0x8e, 0x9f, 0x9e,
        0x94, 0x95, 0x84, 0x85, 0x7a, 0x7b, 0x6a, 0x6b, 0x61, 0x60, 0x71, 0x70,
        0xd1, 0xd0, 0xc1, 0xc0, 0xca, 0xcb, 0xda, 0xdb, 0xc5, 0xc4, 0xd5, 0xd4,
        0xde, 0xdf, 0xce, 0xcf, 0x6e, 0x6f, 0x7e, 0x7f, 0x75, 0x74, 0x65, 0x64,
        0x9b, 0x9a, 0x8b, 0x8a, 0x80, 0x81, 0x90, 0x91, 0x30, 0x31, 0x20, 0x21,
        0x2b, 0x2a, 0x3b, 0x3a, 0x52, 0x53, 0x42, 0x43, 0x49, 0x48, 0x59, 0x58,
        0xf9, 0xf8, 0xe9, 0xe8, 0xe2, 0xe3, 0xf2, 0xf3, 0x0c, 0x0d, 0x1c, 0x1d,
        0x17, 0x16, 0x07, 0x06, 0xa7, 0xa6, 0xb7, 0xb6, 0xbc, 0xbd, 0xac, 0xad,
        0x76, 0x77, 0x66, 0x67, 0x6d, 0x6c, 0x7d, 0x7c, 0xdd, 0xdc, 0xcd, 0xcc,
        0xc6, 0xc7, 0xd6, 0xd7, 0x28, 0x29, 0x38, 0x39, 0x33, 0x32, 0x23, 0x22,
        0x83, 0x82, 0x93, 0x92, 0x98, 0x99, 0x88, 0x89, 0xe1, 0xe0, 0xf1, 0xf0,
        0xfa, 0xfb, 0xea, 0xeb, 0x4a, 0x4b, 0x5a, 0x5b, 0x51, 0x50, 0x41, 0x40,
        0xbf, 0xbe, 0xaf, 0xae, 0xa4, 0xa5, 0xb4, 0xb5, 0x14, 0x15, 0x04, 0x05,
        0x0f, 0x0e, 0x1f, 0x1e
};

const uint8_t sq[] = {
        0x00, 0x01, 0x04, 0x05, 0x10, 0x11, 0x14, 0x15, 0x40, 0x41, 0x44, 0x45,
        0x50, 0x51, 0x54, 0x55, 0x1b, 0x1a, 0x1f, 0x1e, 0x0b, 0x0a, 0x0f, 0x0e,
        0x5b, 0x5a, 0x5f, 0x5e, 0x4b, 0x4a, 0x4f, 0x4e, 0x6c, 0x6d, 0x68, 0x69,
        0x7c, 0x7d, 0x78, 0x79, 0x2c, 0x2d, 0x28, 0x29, 0x3c, 0x3d, 0x38, 0x39,
        0x77, 0x76, 0x73, 0x72, 0x67, 0x66, 0x63, 0x62, 0x37, 0x36, 0x33, 0x32,
        0x27, 0x26, 0x23, 0x22, 0xab, 0xaa, 0xaf, 0xae, 0xbb, 0xba, 0xbf, 0xbe,
        0xeb, 0xea, 0xef, 0xee, 0xfb, 0xfa, 0xff, 0xfe, 0xb0, 0xb1, 0xb4, 0xb5,
        0xa0, 0xa1, 0xa4, 0xa5, 0xf0, 0xf1, 0xf4, 0xf5, 0xe0, 0xe1, 0xe4, 0xe5,
        0xc7, 0xc6, 0xc3, 0xc2, 0xd7, 0xd6, 0xd3, 0xd2, 0x87, 0x86, 0x83, 0x82,
        0x97, 0x96, 0x93, 0x92, 0xdc, 0xdd, 0xd8, 0xd9, 0xcc, 0xcd, 0xc8, 0xc9,
        0x9c, 0x9d, 0x98, 0x99, 0x8c, 0x8d, 0x88, 0x89, 0x9a, 0x9b, 0x9e, 0x9f,
        0x8a, 0x8b, 0x8e, 0x8f, 0xda, 0xdb, 0xde, 0xdf, 0xca, 0xcb, 0xce, 0xcf,
        0x81, 0x80, 0x85, 0x84, 0x91, 0x90, 0x95, 0x94, 0xc1, 0xc0, 0xc5, 0xc4,
        0xd1, 0xd0, 0xd5, 0xd4, 0xf6, 0xf7, 0xf2, 0xf3, 0xe6, 0xe7, 0xe2, 0xe3,
        0xb6, 0xb7, 0xb2, 0xb3, 0xa6, 0xa7, 0xa2, 0xa3, 0xed, 0xec, 0xe9, 0xe8,
        0xfd, 0xfc, 0xf9, 0xf8, 0xad, 0xac, 0xa9, 0xa8, 0xbd, 0xbc, 0xb9, 0xb8,
        0x31, 0x30, 0x35, 0x34, 0x21, 0x20, 0x25, 0x24, 0x71, 0x70, 0x75, 0x74,
        0x61, 0x60, 0x65, 0x64, 0x2a, 0x2b, 0x2e, 0x2f, 0x3a, 0x3b, 0x3e, 0x3f,
        0x6a, 0x6b, 0x6e, 0x6f, 0x7a, 0x7b, 0x7e, 0x7f, 0x5d, 0x5c, 0x59, 0x58,
        0x4d, 0x4c, 0x49, 0x48, 0x1d, 0x1c, 0x19, 0x18, 0x0d, 0x0c, 0x09, 0x08,
        0x46, 0x47, 0x42, 0x43, 0x56, 0x57, 0x52, 0x53, 0x06, 0x07, 0x02, 0x03,
        0x16, 0x17, 0x12, 0x13
};

const uint8_t alog_t[] = {
        0x01, 0x03, 0x05, 0x0f, 0x11, 0x33, 0x55, 0xff, 0x1a, 0x2e, 0x72, 0x96,
        0xa1, 0xf8, 0x13, 0x35, 0x5f, 0xe1, 0x38, 0x48, 0xd8, 0x73, 0x95, 0xa4,
        0xf7, 0x02, 0x06, 0x0a, 0x1e, 0x22, 0x66, 0xaa, 0xe5, 0x34, 0x5c, 0xe4,
        0x37, 0x59, 0xeb, 0x26, 0x6a, 0xbe, 0xd9, 0x70, 0x90, 0xab, 0xe6, 0x31,
        0x53, 0xf5, 0x04, 0x0c, 0x14, 0x3c, 0x44, 0xcc, 0x4f, 0xd1, 0x68, 0xb8,
        0xd3, 0x6e, 0xb2, 0xcd, 0x4c, 0xd4, 0x67, 0xa9, 0xe0, 0x3b, 0x4d, 0xd7,
        0x62, 0xa6, 0xf1, 0x08, 0x18, 0x28, 0x78, 0x88, 0x83, 0x9e, 0xb9, 0xd0,
        0x6b, 0xbd, 0xdc, 0x7f, 0x81, 0x98, 0xb3, 0xce, 0x49, 0xdb, 0x76, 0x9a,
        0xb5, 0xc4, 0x57, 0xf9, 0x10, 0x30, 0x50, 0xf0, 0x0b, 0x1d, 0x27, 0x69,
        0xbb, 0xd6, 0x61, 0xa3, 0xfe, 0x19, 0x2b, 0x7d, 0x87, 0x92, 0xad, 0xec,
        0x2f, 0x71, 0x93, 0xae, 0xe9, 0x20, 0x60, 0xa0, 0xfb, 0x16, 0x3a, 0x4e,
        0xd2, 0x6d, 0xb7, 0xc2, 0x5d, 0xe7, 0x32, 0x56, 0xfa, 0x15, 0x3f, 0x41,
        0xc3, 0x5e, 0xe2, 0x3d, 0x47, 0xc9, 0x40, 0xc0, 0x5b, 0xed, 0x2c, 0x74,
        0x9c, 0xbf, 0xda, 0x75, 0x9f, 0xba, 0xd5, 0x64, 0xac, 0xef, 0x2a, 0x7e,
        0x82, 0x9d, 0xbc, 0xdf, 0x7a, 0x8e, 0x89, 0x80, 0x9b, 0xb6, 0xc1, 0x58,
        0xe8, 0x23, 0x65, 0xaf, 0xea, 0x25, 0x6f, 0xb1, 0xc8, 0x43, 0xc5, 0x54,
        0xfc, 0x1f, 0x21, 0x63, 0xa5, 0xf4, 0x07, 0x09, 0x1b, 0x2d, 0x77, 0x99,
        0xb0, 0xcb, 0x46, 0xca, 0x45, 0xcf, 0x4a, 0xde, 0x79, 0x8b, 0x86, 0x91,
        0xa8, 0xe3, 0x3e, 0x42, 0xc6, 0x51, 0xf3, 0x0e, 0x12, 0x36, 0x5a, 0xee,
        0x29, 0x7b, 0x8d, 0x8c, 0x8f, 0x8a, 0x85, 0x94, 0xa7, 0xf2, 0x0d, 0x17,
        0x39, 0x4b, 0xdd, 0x7c, 0x84, 0x97, 0xa2, 0xfd, 0x1c, 0x24, 0x6c, 0xb4,
        0xc7, 0x52, 0xf6, 0x01
};

const uint8_t log_t[] = {
        0xff, 0x00, 0x19, 0x01, 0x32, 0x02, 0x1a, 0xc6, 0x4b, 0xc7, 0x1b, 0x68,
        0x33, 0xee, 0xdf, 0x03, 0x64, 0x04, 0xe0, 0x0e, 0x34, 0x8d, 0x81, 0xef,
        0x4c, 0x71, 0x08, 0xc8, 0xf8, 0x69, 0x1c, 0xc1, 0x7d, 0xc2, 0x1d, 0xb5,
        0xf9, 0xb9, 0x27, 0x6a, 0x4d, 0xe4, 0xa6, 0x72, 0x9a, 0xc9, 0x09, 0x78,
        0x65, 0x2f, 0x8a, 0x05, 0x21, 0x0f, 0xe1, 0x24, 0x12, 0xf0, 0x82, 0x45,
        0x35, 0x93, 0xda, 0x8e, 0x96, 0x8f, 0xdb, 0xbd, 0x36, 0xd0, 0xce, 0x94,
        0x13, 0x5c, 0xd2, 0xf1, 0x40, 0x46, 0x83, 0x38, 0x66, 0xdd, 0xfd, 0x30,
        0xbf, 0x06, 0x8b, 0x62, 0xb3, 0x25, 0xe2, 0x98, 0x22, 0x88, 0x91, 0x10,
        0x7e, 0x6e, 0x48, 0xc3, 0xa3, 0xb6, 0x1e, 0x42, 0x3a, 0x6b, 0x28, 0x54,
        0xfa, 0x85, 0x3d, 0xba, 0x2b, 0x79, 0x0a, 0x15, 0x9b, 0x9f, 0x5e, 0xca,
        0x4e, 0xd4, 0xac, 0xe5, 0xf3, 0x73, 0xa7, 0x57, 0xaf, 0x58, 0xa8, 0x50,
        0xf4, 0xea, 0xd6, 0x74, 0x4f, 0xae, 0xe9, 0xd5, 0xe7, 0xe6, 0xad, 0xe8,
        0x2c, 0xd7, 0x75, 0x7a, 0xeb, 0x16, 0x0b, 0xf5, 0x59, 0xcb, 0x5f, 0xb0,
        0x9c, 0xa9, 0x51, 0xa0, 0x7f, 0x0c, 0xf6, 0x6f, 0x17, 0xc4, 0x49, 0xec,
        0xd8, 0x43, 0x1f, 0x2d, 0xa4, 0x76, 0x7b, 0xb7, 0xcc, 0xbb, 0x3e, 0x5a,
        0xfb, 0x60, 0xb1, 0x86, 0x3b, 0x52, 0xa1, 0x6c, 0xaa, 0x55, 0x29, 0x9d,
        0x97, 0xb2, 0x87, 0x90, 0x61, 0xbe, 0xdc, 0xfc, 0xbc, 0x95, 0xcf, 0xcd,
        0x37, 0x3f, 0x5b, 0xd1, 0x53, 0x39, 0x84, 0x3c, 0x41, 0xa2, 0x6d, 0x47,
        0x14, 0x2a, 0x9e, 0x5d, 0x56, 0xf2, 0xd3, 0xab, 0x44, 0x11, 0x92, 0xd9,
        0x23, 0x20, 0x2e, 0x89, 0xb4, 0x7c, 0xb8, 0x26, 0x77, 0x99, 0xe3, 0xa5,
        0x67, 0x4a, 0xed, 0xde, 0xc5, 0x31, 0xfe, 0x18, 0x0d, 0x63, 0x8c, 0x80,
        0xc0, 0xf7, 0x70, 0x07
};


void xornprint(uint8_t * x)
{
        int i;
        uint8_t r;

        r=0;
        for (i = 0; i < D; i++)
        {
//                printf("%x+",x[i]);
                r ^= x[i];
        }
//        printf("=%02x\n", r);

}

uint8_t isnotzero(uint8_t n)
{
        return ((n | (~n + 1)) >> 7) & 1;
}

uint8_t spamul(uint8_t a, uint8_t b)
{
        uint8_t t, s, r;
        t = log_t[a];
        s = (t + log_t[b])%256;
        r = alog_t[((s<t) + s)];
        return (isnotzero(a)&isnotzero(b))*r;

}

/* The following sequence of instructions can be used to eliminate the reordering of the two
   spamuls: */
/* r[j][i] = (r[i][j] ^ */
/*            (spamul(x[i], y[j]))); */
/* asm volatile("" ::: "memory"); */
/* r[j][i] ^= spamul(x[j], y[i]); */

/* Alternatively, a GCC pragma of the form: */

/* #pragma GCC push_options */
/* #pragma GCC optimize ("O0") */
/* uint8_t unop_xor(uint8_t r, uint8_t spa_res_a, uint8_t spa_res_b) */
/* { */
/*   return (r^spa_res_a) ^ spa_res_b; */
/* } */
/* #pragma GCC pop_options */


void iswmul(uint8_t * x, uint8_t * y, uint8_t * w)
{
        int i,j;
        uint8_t  r[D][D];

        // TODO: get rid of redundant randomness

	for(i = 0; i < D; i++)
		for(j = 0; j < D; j++)
			r[i][j] = RetRand();

        for (i = 0; i < D; i++)
                for (j = i+1; j < D; j++)
                        r[j][i] = (r[i][j] ^
                                   (spamul(x[i], y[j]))) ^ spamul(x[j], y[i]);

        for (i = 0; i < D; i++)
        {
                w[i] = spamul(x[i], y[i]);
                for (j = 0; j < D; j++)
                {
                       if (i == j)
                               continue;
                       w[i] = w[i]^(r[i][j]);
                }
        }

}

void timul(uint8_t * x, uint8_t * y, uint8_t * w)
{

        int i, j, k;
        uint8_t t[D];

        uint8_t rnd[D-1];

        for (i = 0; i < D-1; i++) 
		rnd[i] = RetRand();

        for (i = 0; i < D; i++)
        {
                t[i] = 0;
                t[i] ^= spamul(x[(i+1)%D], y[(i+1)%D]);
                for (j = 0; j < D; j++)
                {
                        for (k = 0; k < D; k++)
                        {
                                if (j==i || k==i || j==k)
                                        continue;
                                t[i] ^= spamul(x[j], y[k]);
                        }
                }
        }

        w[D-1] = t[D-1];
        for (i = 0; i < D - 1; i++)
        {
                w[i] = t[i] ^ rnd[i];

                w[D-1] ^= rnd[i];
        }

}


void refresh(uint8_t * x)
{
        int i;

        uint8_t rnd[D];

        for(i=0; i<D; i++)
	  rnd[i] = RetRand();
	
        for (i = 1; i < D; i++)
        {
                x[0] ^= rnd[i];
                x[i] ^= rnd[i];

        }

}


void secinvlu(uint8_t * x, uint8_t * y, secmuldef secmul)
{

        int i;
        uint8_t w[D], z[D];


        for (i = 0; i < D; i++)
                z[i]=sq[x[i]];

        refresh(z);

        secmul(z, x, y);


        for (i = 0; i < D; i++)
                w[i] = sq2[y[i]];

        refresh(w);

        secmul(y, w, y);

        for (i = 0; i < D; i++)
                y[i] = sq22[y[i]];

        secmul(y, w, y);

        secmul(y, z, y);

}

void secinvm(uint8_t * x, uint8_t * y, secmuldef secmul)
{

        int i, j;
        uint8_t w[D], z[D], oldy;


        for (i = 0; i < D; i++)
                z[i] = spamul(x[i], x[i]);

        refresh(z);

        secmul(z, x, y);


        for (i = 0; i < D; i++)
        {
                // ^4
                w[i] = spamul(y[i], y[i]);
                for (j = 0; j < 2; j++)
                {
                        w[i] = spamul(w[i], y[i]);
                }
        }

        refresh(w);

        secmul(y, w, y);

        for (i = 0; i < D; i++)
        {
                // ^16
                oldy = y[i];
                y[i] = spamul(y[i], y[i]);
                for (j = 0; j < 14; j++)
                {
                        y[i] = spamul(y[i], oldy);
                }
        }

        secmul(y, w, y);

        secmul(y, z, y);
}



void testmul(uint8_t a, uint8_t b, secmuldef secmul)
{
        uint8_t as[D], bs[D], rs[D];
        int i;

        for(i=0; i<D-1; i++)
        {
	  //as[i] = RetRand();
	  as[i] = 0;
        }

        for(i=0; i<D-1; i++)
        {
	  //bs[i] = RetRand();
	  bs[i] = 0;
        }

        as[D-1] = a;
        bs[D-1] = b;

        secmul(as, bs, rs);

}
